﻿using DataBase;
using MyClasses;
using System.Text;

namespace YaziciAdisyon
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        _ApplicationConnectionDb db = new _ApplicationConnectionDb();
        DarkMIS dr = new DarkMIS();
        Kullanici kb = new Kullanici();

        public void TekliAdisyon()
        {
            foreach (AdisyonSiparisDetaylari item in db.AdisyonSiparisDetaylari.Where(x => x.WebSitesiUrl == kb.WebSitesiUrl).ToList())
            {
                if (item.UrunBagliCihazCiktisi != true)
                {
                    StringBuilder sb = new StringBuilder();
                    sb.AppendLine(kb.WebSitesiUrl);
                    sb.AppendLine("------------------------------------------------");
                    sb.AppendLine($@"Gonderici: {dr.Turkce_Karakterleri_Ingilizceye_Cevir(db.Kullanici.FirstOrDefault(x => x.KullaniciID == item.AdminID).Ad)} {dr.Turkce_Karakterleri_Ingilizceye_Cevir(db.Kullanici.FirstOrDefault(x => x.KullaniciID == item.AdminID).Soyad)}");
                    sb.AppendLine($@"Masa: {dr.Turkce_Karakterleri_Ingilizceye_Cevir(db.AdisyonMasaBilgileri.FirstOrDefault(x => x.Id == item.MasaID).MasaAdi)}");
                    sb.AppendLine("------------------------------------------------");
                    sb.AppendLine($@"Urun: {dr.Turkce_Karakterleri_Ingilizceye_Cevir(db.Urunler.FirstOrDefault(x => x.UrunID == item.SiparisUrunID).Ad)}");
                    foreach (AdisyonUrunSeciliOzellikleri  ozellikler  in db.AdisyonUrunSeciliOzellikleri.Where(x=> x.BaglacID == item.BaglacID && x.Durum == false).ToList())
                    {
                        if (ozellikler.Durum == false)
                        {
                            sb.AppendLine($@"---{dr.Turkce_Karakterleri_Ingilizceye_Cevir(db.UrunlerOzellikleri.FirstOrDefault(x => x.Id == ozellikler.OzellikID).Ozellik)}: {(ozellikler.Durum ? "Var" : "Yok")}");
                        }
                    }
                    sb.AppendLine("------------------------------------------------");
                    sb.AppendLine($@"Tarih: {dr.Turkce_Karakterleri_Ingilizceye_Cevir(DateTime.Now.ToLongDateString())}");
                    sb.AppendLine($@"Saat: {DateTime.Now.ToShortTimeString()}");
                    item.UrunBagliCihazCiktisi = true;
                    db.SaveChanges();
                    var urun = db.Urunler.FirstOrDefault(x => x.UrunID == item.SiparisUrunID);
                    if (urun != null)
                    {
                        var yazici = db.Yazicilar.FirstOrDefault(x => x.ID == urun.YaziciID);
                        if (yazici != null && !string.IsNullOrEmpty(yazici.YaziciIP))
                        {
                            dr.Yazici_Calistir_80MM(yazici.YaziciIP, 9100, sb,true,5000,250);
                        }
                    }
                    sb.Clear();
                }
            }
        }
        public void CokluliAdisyon()
        {
            decimal Toplam = 0;
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(kb.WebSitesiUrl);
            sb.AppendLine("------------------------------------------------");
            foreach (AdisyonSiparisDetaylari item in db.AdisyonSiparisDetaylari.Where(x => x.WebSitesiUrl == kb.WebSitesiUrl && x.Odendi == true && x.UrunKasaCiktisi != true).ToList())
            {
                string UrunBilgileri = $@"{dr.Turkce_Karakterleri_Ingilizceye_Cevir(db.Urunler.FirstOrDefault(x => x.UrunID == item.SiparisUrunID).Ad)} | {db.Urunler.FirstOrDefault(x => x.UrunID == item.SiparisUrunID).GuncelFiyatTL}TL | %{db.Urunler.FirstOrDefault(x => x.UrunID == item.SiparisUrunID).KdvYuzdeTl}KDV";
                sb.AppendLine(UrunBilgileri);
                foreach (AdisyonUrunSeciliOzellikleri ozellikler in db.AdisyonUrunSeciliOzellikleri.Where(x => x.BaglacID == item.BaglacID).ToList())
                {
                    sb.AppendLine($@"---{dr.Turkce_Karakterleri_Ingilizceye_Cevir(db.UrunlerOzellikleri.FirstOrDefault(x => x.Id == ozellikler.OzellikID).Ozellik)}: {(ozellikler.Durum ? "Var" : "Yok")}{(ozellikler.Durum ? $" + {db.UrunlerOzellikleri.FirstOrDefault(x => x.Id == ozellikler.OzellikID).OzellikEkFiyat_TL} TL" : "")}");
                    if (ozellikler.Durum == true)
                    {
                        Toplam += db.UrunlerOzellikleri.FirstOrDefault(x => x.Id == ozellikler.OzellikID).OzellikEkFiyat_TL;
                    }
                }
                item.UrunKasaCiktisi = true;
                Toplam += db.Urunler.FirstOrDefault(x => x.UrunID == item.SiparisUrunID).GuncelFiyatTL;
            }
            sb.AppendLine("------------------------------------------------");
            sb.AppendLine($@"Toplam Hizmet Bedeli: {Toplam} TL");
            sb.AppendLine($@"Tarih: {dr.Turkce_Karakterleri_Ingilizceye_Cevir(DateTime.Now.ToLongDateString())}");
            sb.AppendLine($@"Saat: {DateTime.Now.ToShortTimeString()}");
            if (db.AdisyonSiparisDetaylari.Any(x => x.WebSitesiUrl == kb.WebSitesiUrl && x.Odendi == true && x.UrunKasaCiktisi != true))
            {
                dr.Yazici_Calistir_80MM(
db.Yazicilar.FirstOrDefault(x => x.ID == db.Kullanici.FirstOrDefault(x => x.KullaniciID == kb.KullaniciID).VarsayilanYazici).YaziciIP,
9100,
sb,
false,
5000,
250);
            }
            db.SaveChanges();
            sb.Clear();
        }

        // Admin ID Alma & İnternet Varmı & Cihazlar Bağlımı Kontrolü
        public void Calistir()
        {
            if (dr.Internet_Var_Mı_Kontrol_Et())
            {
                LblBildierim.Text = "Tarih: " + DateTime.Now.ToLongDateString() + " | " + "Saat: " + DateTime.Now.ToShortTimeString();
                tableLayoutPanel1.Show();

                string filePath = @"C:\admin.txt";
                string AdminID = "";
                if (File.Exists(filePath))
                {
                    string firstLine = File.ReadLines(filePath).First();
                    AdminID = firstLine;
                    this.AdminIdTextBox.Text = "Admin Bilgileri Bulundu.";
                    this.AdminIdTextBox.BackColor = Color.LightGreen;
                }
                else
                {
                    this.AdminIdTextBox.Text = "Admin Bilgileri Bulunamadı!!!";
                    this.AdminIdTextBox.BackColor = Color.LightCoral;
                }

                int AdminId = int.Parse(AdminID);
                kb = db.Kullanici.FirstOrDefault(x => x.KullaniciID == AdminId);
                // Sadece YaziciAdi ve YaziciIP'yi gösterecek
                var yaziciVerileri = db.Yazicilar.Where(x => x.AdminID == AdminId).Select(y => new { y.YaziciAdi, y.YaziciIP }).ToList();
                dataGridView1.DataSource = yaziciVerileri;

                // Satır renklerini duruma göre ayarla
                foreach (DataGridViewRow row in dataGridView1.Rows)
                {
                    string ip = row.Cells["YaziciIP"].Value?.ToString();
                    if (ip != null && dr.Agda_Cihaz_Baglimi_Kotnrol_Et(ip))
                    {
                        // Yazıcı bağlı ise arka plan rengi yeşil
                        row.DefaultCellStyle.BackColor = Color.LightGreen;
                    }
                    else
                    {
                        // Yazıcı bağlı değilse arka plan rengi kırmızı
                        row.DefaultCellStyle.BackColor = Color.LightCoral;
                    }
                }
                TekliAdisyon();

                CokluliAdisyon();

            }
            else
            {
                LblBildierim.Text = "İnternet Bağlantısı yok.";
                tableLayoutPanel1.Hide();
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Calistir();
            TimerDinleyici.Start();
        }

        private void TimerDinleyici_Tick(object sender, EventArgs e)
        {
            Calistir();
        }
    }
}
